/* WifiMenuItem.c generated by valac 0.52.2, the Vala compiler
 * generated from WifiMenuItem.vala, do not modify */

/*
 * Copyright (c) 2018 Daniel Pinto (https://github.com/danielpinto8zz6/budgie-network-applet)
 * Copyright (c) 2015-2018 elementary LLC (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "networkapplet.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <NetworkManager.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

enum  {
	NETWORK_WIFI_MENU_ITEM_0_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_NUM_PROPERTIES];
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	NETWORK_WIFI_MENU_ITEM_USER_ACTION_SIGNAL,
	NETWORK_WIFI_MENU_ITEM_NUM_SIGNALS
};
static guint network_wifi_menu_item_signals[NETWORK_WIFI_MENU_ITEM_NUM_SIGNALS] = {0};

struct _NetworkWifiMenuItemPrivate {
	NetworkState _state;
	GBytes* _ssid;
	guint8 _strength;
	GeeLinkedList* all_aps;
	GRecMutex __lock_all_aps;
	GtkImage* img_strength;
	GtkImage* lock_img;
	GtkImage* error_img;
	GtkSpinner* spinner;
	guint refresh_source;
	GRecMutex __lock_refresh_source;
	GtkLabel* network_label;
	GtkLabel* network_state_label;
};

static gint NetworkWifiMenuItem_private_offset;
static gpointer network_wifi_menu_item_parent_class = NULL;
static GType network_wifi_menu_item_type_id = 0;

#define NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME "network-wireless-signal-"
#define NETWORK_WIFI_MENU_ITEM_SYMBOLIC "-symbolic"
static void network_wifi_menu_item_update (NetworkWifiMenuItem* self);
static void network_wifi_menu_item_start_refresh (NetworkWifiMenuItem* self);
static gboolean ____lambda5_ (NetworkWifiMenuItem* self);
static gboolean _____lambda5__gsource_func (gpointer self);
static void network_wifi_menu_item_stop_refresh (NetworkWifiMenuItem* self);
static void network_wifi_menu_item_hide_item (NetworkWifiMenuItem* self,
                                       GtkWidget* w);
static void network_wifi_menu_item_show_item (NetworkWifiMenuItem* self,
                                       GtkWidget* w);
static void network_wifi_menu_item_set_strength (NetworkWifiMenuItem* self,
                                          guint8 value);
static const gchar* network_wifi_menu_item_get_strength_symbolic_icon (NetworkWifiMenuItem* self);
static GObject * network_wifi_menu_item_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _network_wifi_menu_item_update_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void _network_wifi_menu_item___lambda6_ (NetworkWifiMenuItem* self);
static void __network_wifi_menu_item___lambda6__gtk_widget_map (GtkWidget* _sender,
                                                         gpointer self);
static void _network_wifi_menu_item___lambda7_ (NetworkWifiMenuItem* self);
static void __network_wifi_menu_item___lambda7__gtk_widget_unmap (GtkWidget* _sender,
                                                           gpointer self);
static void network_wifi_menu_item_finalize (GObject * obj);
static void _vala_network_wifi_menu_item_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_network_wifi_menu_item_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
network_wifi_menu_item_get_instance_private (NetworkWifiMenuItem* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkWifiMenuItem_private_offset);
}

NetworkWifiMenuItem*
network_wifi_menu_item_construct (GType object_type,
                                  NMAccessPoint* ap,
                                  NetworkWifiMenuItem* previous)
{
	NetworkWifiMenuItem * self = NULL;
	GBytes* _tmp0_;
	GBytes* _tmp1_;
	g_return_val_if_fail (ap != NULL, NULL);
	_tmp0_ = nm_access_point_get_ssid (ap);
	_tmp1_ = _tmp0_;
	self = (NetworkWifiMenuItem*) g_object_new (object_type, "ssid", _tmp1_, "margin-top", 3, NULL);
	network_wifi_menu_item_add_ap (self, ap);
	gtk_widget_show_all ((GtkWidget*) self);
	return self;
}

NetworkWifiMenuItem*
network_wifi_menu_item_new (NMAccessPoint* ap,
                            NetworkWifiMenuItem* previous)
{
	return network_wifi_menu_item_construct (NETWORK_TYPE_WIFI_MENU_ITEM, ap, previous);
}

void
network_wifi_menu_item_add_ap (NetworkWifiMenuItem* self,
                               NMAccessPoint* ap)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ap != NULL);
	{
		GeeLinkedList* _tmp0_;
		_tmp0_ = self->priv->all_aps;
		g_rec_mutex_lock (&self->priv->__lock_all_aps);
		{
			GeeLinkedList* _tmp1_;
			_tmp1_ = self->priv->all_aps;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, ap);
		}
		__finally0:
		{
			GeeLinkedList* _tmp2_;
			_tmp2_ = self->priv->all_aps;
			g_rec_mutex_unlock (&self->priv->__lock_all_aps);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	network_wifi_menu_item_update (self);
}

gboolean
network_wifi_menu_item_remove_ap (NetworkWifiMenuItem* self,
                                  NMAccessPoint* ap)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (ap != NULL, FALSE);
	{
		GeeLinkedList* _tmp0_;
		gboolean _tmp7_ = FALSE;
		_tmp0_ = self->priv->all_aps;
		g_rec_mutex_lock (&self->priv->__lock_all_aps);
		{
			GeeLinkedList* _tmp1_;
			GeeLinkedList* _tmp2_;
			gboolean _tmp3_;
			gboolean _tmp4_;
			_tmp1_ = self->priv->all_aps;
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, ap);
			_tmp2_ = self->priv->all_aps;
			_tmp3_ = gee_collection_get_is_empty ((GeeCollection*) _tmp2_);
			_tmp4_ = _tmp3_;
			result = !_tmp4_;
			{
				GeeLinkedList* _tmp5_;
				_tmp5_ = self->priv->all_aps;
				g_rec_mutex_unlock (&self->priv->__lock_all_aps);
			}
			return result;
		}
		__finally0:
		{
			GeeLinkedList* _tmp6_;
			_tmp6_ = self->priv->all_aps;
			g_rec_mutex_unlock (&self->priv->__lock_all_aps);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp7_;
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

NMAccessPoint*
network_wifi_menu_item_get_nearest_ap (NetworkWifiMenuItem* self)
{
	GError* _inner_error0_ = NULL;
	NMAccessPoint* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		GeeLinkedList* _tmp0_;
		_tmp0_ = self->priv->all_aps;
		g_rec_mutex_lock (&self->priv->__lock_all_aps);
		{
			NMAccessPoint* ap = NULL;
			GeeLinkedList* _tmp1_;
			gpointer _tmp2_;
			_tmp1_ = self->priv->all_aps;
			_tmp2_ = gee_linked_list_first (_tmp1_);
			ap = (NMAccessPoint*) _tmp2_;
			{
				GeeLinkedList* _iter_ap_list = NULL;
				GeeLinkedList* _tmp3_;
				gint _iter_ap_size = 0;
				GeeLinkedList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _iter_ap_index = 0;
				_tmp3_ = self->priv->all_aps;
				_iter_ap_list = _tmp3_;
				_tmp4_ = _iter_ap_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_iter_ap_size = _tmp6_;
				_iter_ap_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					NMAccessPoint* iter_ap = NULL;
					GeeLinkedList* _tmp9_;
					gpointer _tmp10_;
					NMAccessPoint* _tmp11_;
					guint8 _tmp12_;
					guint8 _tmp13_;
					NMAccessPoint* _tmp14_;
					guint8 _tmp15_;
					guint8 _tmp16_;
					_iter_ap_index = _iter_ap_index + 1;
					_tmp7_ = _iter_ap_index;
					_tmp8_ = _iter_ap_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _iter_ap_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _iter_ap_index);
					iter_ap = (NMAccessPoint*) _tmp10_;
					_tmp11_ = ap;
					_tmp12_ = nm_access_point_get_strength (_tmp11_);
					_tmp13_ = _tmp12_;
					_tmp14_ = iter_ap;
					_tmp15_ = nm_access_point_get_strength (_tmp14_);
					_tmp16_ = _tmp15_;
					if (_tmp13_ < _tmp16_) {
						NMAccessPoint* _tmp17_;
						NMAccessPoint* _tmp18_;
						_tmp17_ = iter_ap;
						_tmp18_ = _g_object_ref0 (_tmp17_);
						_g_object_unref0 (ap);
						ap = _tmp18_;
					}
					_g_object_unref0 (iter_ap);
				}
			}
			result = ap;
			{
				GeeLinkedList* _tmp19_;
				_tmp19_ = self->priv->all_aps;
				g_rec_mutex_unlock (&self->priv->__lock_all_aps);
			}
			return result;
		}
		__finally0:
		{
			GeeLinkedList* _tmp20_;
			_tmp20_ = self->priv->all_aps;
			g_rec_mutex_unlock (&self->priv->__lock_all_aps);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

static gboolean
____lambda5_ (NetworkWifiMenuItem* self)
{
	gboolean result = FALSE;
	network_wifi_menu_item_update (self);
	result = G_SOURCE_CONTINUE;
	return result;
}

static gboolean
_____lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda5_ ((NetworkWifiMenuItem*) self);
	return result;
}

static void
network_wifi_menu_item_start_refresh (NetworkWifiMenuItem* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		g_rec_mutex_lock (&self->priv->__lock_refresh_source);
		{
			if (self->priv->refresh_source > ((guint) 0)) {
				g_source_remove (self->priv->refresh_source);
			}
			self->priv->refresh_source = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 5, _____lambda5__gsource_func, g_object_ref (self), g_object_unref);
		}
		__finally0:
		{
			g_rec_mutex_unlock (&self->priv->__lock_refresh_source);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

static void
network_wifi_menu_item_stop_refresh (NetworkWifiMenuItem* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		g_rec_mutex_lock (&self->priv->__lock_refresh_source);
		{
			g_source_remove (self->priv->refresh_source);
			self->priv->refresh_source = (guint) 0;
		}
		__finally0:
		{
			g_rec_mutex_unlock (&self->priv->__lock_refresh_source);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

static void
network_wifi_menu_item_update (NetworkWifiMenuItem* self)
{
	GtkLabel* _tmp0_;
	GBytes* _tmp1_;
	gsize _tmp2_ = 0;
	guint8* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	NMAccessPoint* ap = NULL;
	NM80211ApSecurityFlags flags = 0U;
	NMAccessPoint* _tmp10_;
	NM80211ApSecurityFlags _tmp11_;
	NM80211ApSecurityFlags _tmp12_;
	gboolean is_secured = FALSE;
	NM80211ApSecurityFlags _tmp13_;
	const gchar* _tmp21_ = NULL;
	GtkImage* _tmp22_;
	GtkImage* _tmp23_;
	GtkSpinner* _tmp24_;
	NetworkState _tmp25_;
	guint8 next_strength = 0U;
	GtkImage* _tmp45_;
	const gchar* _tmp46_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->network_label;
	_tmp1_ = self->priv->_ssid;
	_tmp3_ = g_bytes_get_data (_tmp1_, &_tmp2_);
	_tmp4_ = nm_utils_ssid_to_utf8 (_tmp3_, (gsize) _tmp2_);
	_tmp5_ = _tmp4_;
	gtk_label_set_label (_tmp0_, _tmp5_);
	_g_free0 (_tmp5_);
	ap = NULL;
	{
		GeeLinkedList* _tmp6_;
		_tmp6_ = self->priv->all_aps;
		g_rec_mutex_lock (&self->priv->__lock_all_aps);
		{
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			_tmp7_ = self->priv->all_aps;
			_tmp8_ = gee_linked_list_first (_tmp7_);
			_g_object_unref0 (ap);
			ap = (NMAccessPoint*) _tmp8_;
		}
		__finally0:
		{
			GeeLinkedList* _tmp9_;
			_tmp9_ = self->priv->all_aps;
			g_rec_mutex_unlock (&self->priv->__lock_all_aps);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (ap);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp10_ = ap;
	_tmp11_ = nm_access_point_get_wpa_flags (_tmp10_);
	_tmp12_ = _tmp11_;
	flags = _tmp12_;
	is_secured = FALSE;
	_tmp13_ = flags;
	if ((_tmp13_ & NM_802_11_AP_SEC_GROUP_WEP40) == NM_802_11_AP_SEC_GROUP_WEP40) {
		is_secured = TRUE;
		gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network uses 40/64-bit WEP encryption"));
	} else {
		NM80211ApSecurityFlags _tmp14_;
		_tmp14_ = flags;
		if ((_tmp14_ & NM_802_11_AP_SEC_GROUP_WEP104) == NM_802_11_AP_SEC_GROUP_WEP104) {
			is_secured = TRUE;
			gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network uses 104/128-bit WEP encryption"));
		} else {
			NM80211ApSecurityFlags _tmp15_;
			_tmp15_ = flags;
			if ((_tmp15_ & NM_802_11_AP_SEC_KEY_MGMT_PSK) == NM_802_11_AP_SEC_KEY_MGMT_PSK) {
				is_secured = TRUE;
				gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network uses WPA encryption"));
			} else {
				gboolean _tmp16_ = FALSE;
				NM80211ApSecurityFlags _tmp17_;
				_tmp17_ = flags;
				if (_tmp17_ != NM_802_11_AP_SEC_NONE) {
					_tmp16_ = TRUE;
				} else {
					NMAccessPoint* _tmp18_;
					NM80211ApSecurityFlags _tmp19_;
					NM80211ApSecurityFlags _tmp20_;
					_tmp18_ = ap;
					_tmp19_ = nm_access_point_get_rsn_flags (_tmp18_);
					_tmp20_ = _tmp19_;
					_tmp16_ = _tmp20_ != NM_802_11_AP_SEC_NONE;
				}
				if (_tmp16_) {
					is_secured = TRUE;
					gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network uses encryption"));
				} else {
					gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network is unsecured"));
				}
			}
		}
	}
	if (is_secured) {
		_tmp21_ = "channel-secure-symbolic";
	} else {
		_tmp21_ = "channel-insecure-symbolic";
	}
	_tmp22_ = self->priv->lock_img;
	g_object_set (_tmp22_, "icon-name", _tmp21_, NULL);
	_tmp23_ = self->priv->error_img;
	network_wifi_menu_item_hide_item (self, (GtkWidget*) _tmp23_);
	_tmp24_ = self->priv->spinner;
	network_wifi_menu_item_hide_item (self, (GtkWidget*) _tmp24_);
	_tmp25_ = self->priv->_state;
	switch (_tmp25_) {
		case NETWORK_STATE_FAILED_WIFI:
		{
			GtkImage* _tmp26_;
			GtkLabel* _tmp27_;
			_tmp26_ = self->priv->error_img;
			network_wifi_menu_item_show_item (self, (GtkWidget*) _tmp26_);
			_tmp27_ = self->priv->network_state_label;
			gtk_label_set_label (_tmp27_, _ ("Failed to connect"));
			break;
		}
		case NETWORK_STATE_CONNECTING_WIFI:
		{
			GtkSpinner* _tmp28_;
			GtkLabel* _tmp29_;
			_tmp28_ = self->priv->spinner;
			network_wifi_menu_item_show_item (self, (GtkWidget*) _tmp28_);
			_tmp29_ = self->priv->network_state_label;
			gtk_label_set_label (_tmp29_, _ ("Connecting"));
			break;
		}
		case NETWORK_STATE_CONNECTED_WIFI:
		case NETWORK_STATE_CONNECTED_WIFI_WEAK:
		case NETWORK_STATE_CONNECTED_WIFI_OK:
		case NETWORK_STATE_CONNECTED_WIFI_GOOD:
		case NETWORK_STATE_CONNECTED_WIFI_EXCELLENT:
		{
			GtkLabel* _tmp30_;
			_tmp30_ = self->priv->network_state_label;
			gtk_label_set_label (_tmp30_, _ ("Connected"));
			break;
		}
		default:
		{
			GtkLabel* _tmp31_;
			_tmp31_ = self->priv->network_state_label;
			gtk_label_set_label (_tmp31_, _ ("Disconnected"));
			break;
		}
	}
	next_strength = (guint8) 0;
	{
		GeeLinkedList* _tmp32_;
		_tmp32_ = self->priv->all_aps;
		g_rec_mutex_lock (&self->priv->__lock_all_aps);
		{
			{
				GeeLinkedList* _iter_ap_list = NULL;
				GeeLinkedList* _tmp33_;
				gint _iter_ap_size = 0;
				GeeLinkedList* _tmp34_;
				gint _tmp35_;
				gint _tmp36_;
				gint _iter_ap_index = 0;
				_tmp33_ = self->priv->all_aps;
				_iter_ap_list = _tmp33_;
				_tmp34_ = _iter_ap_list;
				_tmp35_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp34_);
				_tmp36_ = _tmp35_;
				_iter_ap_size = _tmp36_;
				_iter_ap_index = -1;
				while (TRUE) {
					gint _tmp37_;
					gint _tmp38_;
					NMAccessPoint* iter_ap = NULL;
					GeeLinkedList* _tmp39_;
					gpointer _tmp40_;
					NMAccessPoint* _tmp41_;
					guint8 _tmp42_;
					guint8 _tmp43_;
					_iter_ap_index = _iter_ap_index + 1;
					_tmp37_ = _iter_ap_index;
					_tmp38_ = _iter_ap_size;
					if (!(_tmp37_ < _tmp38_)) {
						break;
					}
					_tmp39_ = _iter_ap_list;
					_tmp40_ = gee_abstract_list_get ((GeeAbstractList*) _tmp39_, _iter_ap_index);
					iter_ap = (NMAccessPoint*) _tmp40_;
					_tmp41_ = iter_ap;
					_tmp42_ = nm_access_point_get_strength (_tmp41_);
					_tmp43_ = _tmp42_;
					next_strength = MAX (next_strength, _tmp43_);
					_g_object_unref0 (iter_ap);
				}
			}
		}
		__finally1:
		{
			GeeLinkedList* _tmp44_;
			_tmp44_ = self->priv->all_aps;
			g_rec_mutex_unlock (&self->priv->__lock_all_aps);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (ap);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	network_wifi_menu_item_set_strength (self, next_strength);
	_tmp45_ = self->priv->img_strength;
	_tmp46_ = network_wifi_menu_item_get_strength_symbolic_icon (self);
	g_object_set (_tmp45_, "icon-name", _tmp46_, NULL);
	_g_object_unref0 (ap);
}

static void
network_wifi_menu_item_show_item (NetworkWifiMenuItem* self,
                                  GtkWidget* w)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (w != NULL);
	gtk_widget_set_visible (w, TRUE);
	_tmp0_ = gtk_widget_get_visible (w);
	_tmp1_ = _tmp0_;
	gtk_widget_set_no_show_all (w, !_tmp1_);
}

static void
network_wifi_menu_item_hide_item (NetworkWifiMenuItem* self,
                                  GtkWidget* w)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (w != NULL);
	gtk_widget_set_visible (w, FALSE);
	_tmp0_ = gtk_widget_get_visible (w);
	_tmp1_ = _tmp0_;
	gtk_widget_set_no_show_all (w, !_tmp1_);
	gtk_widget_hide (w);
}

static const gchar*
network_wifi_menu_item_get_strength_symbolic_icon (NetworkWifiMenuItem* self)
{
	guint8 _tmp0_;
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_strength;
	if (((gint) _tmp0_) < 30) {
		result = NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME "weak" NETWORK_WIFI_MENU_ITEM_SYMBOLIC;
		return result;
	} else {
		guint8 _tmp1_;
		_tmp1_ = self->priv->_strength;
		if (((gint) _tmp1_) < 55) {
			result = NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME "ok" NETWORK_WIFI_MENU_ITEM_SYMBOLIC;
			return result;
		} else {
			guint8 _tmp2_;
			_tmp2_ = self->priv->_strength;
			if (((gint) _tmp2_) < 80) {
				result = NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME "good" NETWORK_WIFI_MENU_ITEM_SYMBOLIC;
				return result;
			} else {
				result = NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME "excellent" NETWORK_WIFI_MENU_ITEM_SYMBOLIC;
				return result;
			}
		}
	}
}

NetworkState
network_wifi_menu_item_get_state (NetworkWifiMenuItem* self)
{
	NetworkState result;
	NetworkState _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_state;
	result = _tmp0_;
	return result;
}

void
network_wifi_menu_item_set_state (NetworkWifiMenuItem* self,
                                  NetworkState value)
{
	NetworkState old_value;
	g_return_if_fail (self != NULL);
	old_value = network_wifi_menu_item_get_state (self);
	if (old_value != value) {
		self->priv->_state = value;
		g_object_notify_by_pspec ((GObject *) self, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY]);
	}
}

GBytes*
network_wifi_menu_item_get_ssid (NetworkWifiMenuItem* self)
{
	GBytes* result;
	GBytes* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_ssid;
	result = _tmp0_;
	return result;
}

static gpointer
_g_bytes_ref0 (gpointer self)
{
	return self ? g_bytes_ref (self) : NULL;
}

static void
network_wifi_menu_item_set_ssid (NetworkWifiMenuItem* self,
                                 GBytes* value)
{
	GBytes* old_value;
	g_return_if_fail (self != NULL);
	old_value = network_wifi_menu_item_get_ssid (self);
	if (old_value != value) {
		GBytes* _tmp0_;
		_tmp0_ = _g_bytes_ref0 (value);
		_g_bytes_unref0 (self->priv->_ssid);
		self->priv->_ssid = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY]);
	}
}

guint8
network_wifi_menu_item_get_strength (NetworkWifiMenuItem* self)
{
	guint8 result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_strength;
	return result;
}

static void
network_wifi_menu_item_set_strength (NetworkWifiMenuItem* self,
                                     guint8 value)
{
	guint8 old_value;
	g_return_if_fail (self != NULL);
	old_value = network_wifi_menu_item_get_strength (self);
	if (old_value != value) {
		self->priv->_strength = value;
		g_object_notify_by_pspec ((GObject *) self, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY]);
	}
}

static void
_network_wifi_menu_item_update_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
	network_wifi_menu_item_update ((NetworkWifiMenuItem*) self);
}

static void
_network_wifi_menu_item___lambda6_ (NetworkWifiMenuItem* self)
{
	network_wifi_menu_item_start_refresh (self);
}

static void
__network_wifi_menu_item___lambda6__gtk_widget_map (GtkWidget* _sender,
                                                    gpointer self)
{
	_network_wifi_menu_item___lambda6_ ((NetworkWifiMenuItem*) self);
}

static void
_network_wifi_menu_item___lambda7_ (NetworkWifiMenuItem* self)
{
	network_wifi_menu_item_stop_refresh (self);
}

static void
__network_wifi_menu_item___lambda7__gtk_widget_unmap (GtkWidget* _sender,
                                                      gpointer self)
{
	_network_wifi_menu_item___lambda7_ ((NetworkWifiMenuItem*) self);
}

static GObject *
network_wifi_menu_item_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkWifiMenuItem * self;
	GeeLinkedList* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkImage* _tmp10_;
	GtkImage* _tmp11_;
	GtkImage* _tmp12_;
	GtkImage* _tmp13_;
	GtkImage* _tmp14_;
	GtkImage* _tmp15_;
	GtkImage* _tmp16_;
	GtkSpinner* _tmp17_;
	GtkSpinner* _tmp18_;
	GtkSpinner* _tmp19_;
	GtkSpinner* _tmp20_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp21_;
	GtkGrid* _tmp22_;
	GtkGrid* _tmp23_;
	GtkImage* _tmp24_;
	GtkGrid* _tmp25_;
	GtkLabel* _tmp26_;
	GtkImage* _tmp27_;
	GtkGrid* _tmp28_;
	GtkLabel* _tmp29_;
	GtkLabel* _tmp30_;
	GtkGrid* _tmp31_;
	GtkSpinner* _tmp32_;
	GtkLabel* _tmp33_;
	GtkGrid* _tmp34_;
	GtkImage* _tmp35_;
	GtkSpinner* _tmp36_;
	GtkGrid* _tmp37_;
	GtkImage* _tmp38_;
	GtkImage* _tmp39_;
	GtkGrid* _tmp40_;
	parent_class = G_OBJECT_CLASS (network_wifi_menu_item_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
	_tmp0_ = gee_linked_list_new (nm_access_point_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->all_aps);
	self->priv->all_aps = _tmp0_;
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp1_, "menuitem");
	_tmp2_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->network_label);
	self->priv->network_label = _tmp2_;
	_tmp3_ = self->priv->network_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_START);
	_tmp4_ = self->priv->network_label;
	g_object_set ((GtkWidget*) _tmp4_, "expand", TRUE, NULL);
	_tmp5_ = self->priv->network_label;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp5_, 6);
	_tmp6_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->network_state_label);
	self->priv->network_state_label = _tmp6_;
	_tmp7_ = self->priv->network_state_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_START);
	_tmp8_ = self->priv->network_state_label;
	g_object_set ((GtkWidget*) _tmp8_, "expand", TRUE, NULL);
	_tmp9_ = self->priv->network_state_label;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp9_, 6);
	_tmp10_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->priv->img_strength);
	self->priv->img_strength = _tmp10_;
	_tmp11_ = self->priv->img_strength;
	g_object_set (_tmp11_, "icon-size", (gint) GTK_ICON_SIZE_LARGE_TOOLBAR, NULL);
	_tmp12_ = self->priv->img_strength;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp12_, 6);
	_tmp13_ = (GtkImage*) gtk_image_new_from_icon_name ("channel-secure-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp13_);
	_g_object_unref0 (self->priv->lock_img);
	self->priv->lock_img = _tmp13_;
	_tmp14_ = self->priv->lock_img;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp14_, 6);
	_tmp15_ = (GtkImage*) gtk_image_new_from_icon_name ("process-error-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->error_img);
	self->priv->error_img = _tmp15_;
	_tmp16_ = self->priv->error_img;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp16_, _ ("This wireless network could not be connected to."));
	_tmp17_ = (GtkSpinner*) gtk_spinner_new ();
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->spinner);
	self->priv->spinner = _tmp17_;
	_tmp18_ = self->priv->spinner;
	gtk_spinner_start (_tmp18_);
	_tmp19_ = self->priv->spinner;
	gtk_widget_set_visible ((GtkWidget*) _tmp19_, FALSE);
	_tmp20_ = self->priv->spinner;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp20_, TRUE);
	_tmp21_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp21_);
	grid = _tmp21_;
	_tmp22_ = grid;
	gtk_grid_set_column_spacing (_tmp22_, 6);
	_tmp23_ = grid;
	_tmp24_ = self->priv->img_strength;
	gtk_grid_attach (_tmp23_, (GtkWidget*) _tmp24_, 0, 0, 1, 2);
	_tmp25_ = grid;
	_tmp26_ = self->priv->network_label;
	_tmp27_ = self->priv->img_strength;
	gtk_grid_attach_next_to (_tmp25_, (GtkWidget*) _tmp26_, (GtkWidget*) _tmp27_, GTK_POS_RIGHT, 1, 1);
	_tmp28_ = grid;
	_tmp29_ = self->priv->network_state_label;
	_tmp30_ = self->priv->network_label;
	gtk_grid_attach_next_to (_tmp28_, (GtkWidget*) _tmp29_, (GtkWidget*) _tmp30_, GTK_POS_BOTTOM, 1, 1);
	_tmp31_ = grid;
	_tmp32_ = self->priv->spinner;
	_tmp33_ = self->priv->network_label;
	gtk_grid_attach_next_to (_tmp31_, (GtkWidget*) _tmp32_, (GtkWidget*) _tmp33_, GTK_POS_RIGHT, 1, 2);
	_tmp34_ = grid;
	_tmp35_ = self->priv->error_img;
	_tmp36_ = self->priv->spinner;
	gtk_grid_attach_next_to (_tmp34_, (GtkWidget*) _tmp35_, (GtkWidget*) _tmp36_, GTK_POS_RIGHT, 1, 2);
	_tmp37_ = grid;
	_tmp38_ = self->priv->lock_img;
	_tmp39_ = self->priv->error_img;
	gtk_grid_attach_next_to (_tmp37_, (GtkWidget*) _tmp38_, (GtkWidget*) _tmp39_, GTK_POS_RIGHT, 1, 2);
	_tmp40_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp40_);
	g_signal_connect_object ((GObject*) self, "notify::state", (GCallback) _network_wifi_menu_item_update_g_object_notify, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "map", (GCallback) __network_wifi_menu_item___lambda6__gtk_widget_map, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "unmap", (GCallback) __network_wifi_menu_item___lambda7__gtk_widget_unmap, self, 0);
	_g_object_unref0 (grid);
	return obj;
}

static void
network_wifi_menu_item_class_init (NetworkWifiMenuItemClass * klass,
                                   gpointer klass_data)
{
	network_wifi_menu_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NetworkWifiMenuItem_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_network_wifi_menu_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_network_wifi_menu_item_set_property;
	G_OBJECT_CLASS (klass)->constructor = network_wifi_menu_item_constructor;
	G_OBJECT_CLASS (klass)->finalize = network_wifi_menu_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", NETWORK_TYPE_STATE, NETWORK_STATE_DISCONNECTED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY] = g_param_spec_boxed ("ssid", "ssid", "ssid", G_TYPE_BYTES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY] = g_param_spec_uchar ("strength", "strength", "strength", 0, G_MAXUINT8, (guint8) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	network_wifi_menu_item_signals[NETWORK_WIFI_MENU_ITEM_USER_ACTION_SIGNAL] = g_signal_new ("user-action", NETWORK_TYPE_WIFI_MENU_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
network_wifi_menu_item_instance_init (NetworkWifiMenuItem * self,
                                      gpointer klass)
{
	self->priv = network_wifi_menu_item_get_instance_private (self);
	self->priv->_state = NETWORK_STATE_DISCONNECTED;
	self->priv->_strength = (guint8) 0;
	g_rec_mutex_init (&self->priv->__lock_all_aps);
	g_rec_mutex_init (&self->priv->__lock_refresh_source);
	self->priv->refresh_source = (guint) 0;
}

static void
network_wifi_menu_item_finalize (GObject * obj)
{
	NetworkWifiMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
	_g_bytes_unref0 (self->priv->_ssid);
	g_rec_mutex_clear (&self->priv->__lock_all_aps);
	_g_object_unref0 (self->priv->all_aps);
	_g_object_unref0 (self->priv->img_strength);
	_g_object_unref0 (self->priv->lock_img);
	_g_object_unref0 (self->priv->error_img);
	_g_object_unref0 (self->priv->spinner);
	g_rec_mutex_clear (&self->priv->__lock_refresh_source);
	_g_object_unref0 (self->priv->network_label);
	_g_object_unref0 (self->priv->network_state_label);
	G_OBJECT_CLASS (network_wifi_menu_item_parent_class)->finalize (obj);
}

GType
network_wifi_menu_item_get_type (void)
{
	return network_wifi_menu_item_type_id;
}

GType
network_wifi_menu_item_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkWifiMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_wifi_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWifiMenuItem), 0, (GInstanceInitFunc) network_wifi_menu_item_instance_init, NULL };
	network_wifi_menu_item_type_id = g_type_module_register_type (module, gtk_list_box_row_get_type (), "NetworkWifiMenuItem", &g_define_type_info, 0);
	NetworkWifiMenuItem_private_offset = sizeof (NetworkWifiMenuItemPrivate);
	return network_wifi_menu_item_type_id;
}

static void
_vala_network_wifi_menu_item_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
	switch (property_id) {
		case NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY:
		g_value_set_enum (value, network_wifi_menu_item_get_state (self));
		break;
		case NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY:
		g_value_set_boxed (value, network_wifi_menu_item_get_ssid (self));
		break;
		case NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY:
		g_value_set_uchar (value, network_wifi_menu_item_get_strength (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_network_wifi_menu_item_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
	switch (property_id) {
		case NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY:
		network_wifi_menu_item_set_state (self, g_value_get_enum (value));
		break;
		case NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY:
		network_wifi_menu_item_set_ssid (self, g_value_get_boxed (value));
		break;
		case NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY:
		network_wifi_menu_item_set_strength (self, g_value_get_uchar (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

